#include "BoostPreprocessorThread.h"
#include "Camera.h"
#include "KdTree.h"
#include "SceneGraph.h"
#include "Preprocessor.h"
#include <boost/thread/thread.hpp>

namespace GtpVisibilityPreprocessor {


BoostPreprocessorThread::BoostPreprocessorThread(Preprocessor *p):
PreprocessorThread(p), mThread(NULL)
{
}


void BoostPreprocessorThread::operator()()
{
	Main();
}




BoostPreprocessorThread::~BoostPreprocessorThread()
{
  cerr << "Boost Preprocessor thread destructor ... \n";
  DEL_PTR(mThread);
}


void BoostPreprocessorThread::InitThread()
{
  mThread = new boost::thread(*this);
}


void BoostPreprocessorThread::RunThread()
{
	Main();
  //mThread->join();
}

}
